mod Ex09 logic: 'cl'

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Maux

incl Mxprf

incl Mxu

incl Mxprt

incl Mxop

rem 
  \para \bf  9. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 23.11.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane p.r. indexom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mxu.cl  \end obsahuje interpreter p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mxprt.cl  \end obsahuje aritmetizaciu p.r. termov. 
   \item \para Subor \it  mxop.cl  \end obsahuje niektore operacie na p.r. 
         indexoch. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: - 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 2 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 5.12.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  [CL] Remark.  \end Clausal language is allowed. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion.  \end 

rem 
  \para \bf  Subsection. Universal Function for Primitive Recursive Functions is 
  not Primitive Recursive.  \end 

rem 
  \para \bf  Arithmetization of p.r. function symbols.  \end See also the module 
  \ft Mxprf \end. 

rem 
  \para \bf  Interpeter of p.r. function symbols.  \end See also the module 
  \ft Mxu \end. 

rem 
  \para \bf  Primitive recursive indices.  \end See also the predicate 
  \ft Prf(e) \end holding of well-formed p.r. indices in the module 
  \ft Mxprf \end. 

rem 
  \para \bf  Effective operations on p.r. indices.  \end See also the module 
  \ft Mxop \end. 

rem 
  \para \bf  Exercise.  \end \header* fun Xdiag 'Tex_f1_xpr_xdiag' \end Define a 
  primitive recursive function \ft Xdiag(e) \end satisfying 
  \eq* 
    U(Xdiag(e),x) = U(e,x,x)
  \end
  \para In other words, if \ft e \end is a p.r. index of a binary function then 
  \ft Xdiag(e) \end is a p.r. index of its diagonalization. 

fun Xdiag 'Tex_f1_xpr_xdiag'
  Xdiag(e) = Foo

thm Spec_xdiag
  U(Xdiag(e),x) = U(e,x,x)

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Xcantor 'Tex_f0_xpr_xcantor' \end 
  \header* fun Xu2 'Tex_f0_xpr_xu2' \end Show that the binary function 
  \ft U(e,x) \end is not primitive recursive, that is 
  \eq* 
    ~\e e\a x\a y U(e,x,y) = U(x,y)
  \end
  \para or equivalently 
  \eq* 
    \a e\e x\e y U(e,x,y) != U(x,y)
  \end
  \para by providing a primitive recursive function \ft Xcantor(e) \end 
  satisfying 
  \eq* 
    U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))
  \end

fun Xcantor 'Tex_f0_xpr_xcantor'
  Xcantor(e) = Foo

thm Spec_xcantor
  U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun/0 Xself 'Tex_f0_xpr_xself' \end Find a number \ft Xself \end such 
  that 
  \eq* 
    Ar(Xself) = 1
  \end
  \eq* 
    Prf(Xself)
  \end
  \eq* 
    U(Xself,x) = Xself
  \end
  \para In other words, the number \ft Xself \end is a well-formed p.r. index of 
  a unary function which, regardless of input, produces its own description as 
  the output. 

fun/0 Xself 'Tex_f0_xpr_xself'
  Xself = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

