mod Maux

incl Mtex

incl Mtexrc

rem 
  \para \bf  Exponentiation.  \end 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

rem 
  \para \bf  Catalan pairing function.  \end 

rem 
  \para \it  Projections.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

fun/2 Iproj1 'Tex_f2_pp_iproj1'
  Iproj1(0,x) = x
  Iproj1(n+1,x) = Proj1 Iproj1(n,x)

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

